//=============================================================================//
//  ___  ___   _   _   _    __   _   ___ ___ __ __
// |_ _|| __| / \ | \_/ |  / _| / \ | o \ o \\ V /
//  | | | _| | o || \_/ | ( |_n| o ||   /   / \ / 
//  |_| |___||_n_||_| |_|  \__/|_n_||_|\\_|\\ |_|  2008
//										 
//=============================================================================//

/////////////////////////////////////////////////////////////////////////////////
// M     M RRRRRR     PPPPPP  U     U FFFFFF FFFFFF Y    Y   :D
// MM   MM R     R    P     P U     U F      F       Y  Y    :D
// M M M M RRRRRR     PPPPPP  U     U FFFFFF FFFFFF   YY     :D
// M  M  M R   R      P       U     U F      F        Y      
// M     M R    R     P        UUUUU  F      F       Y       :D
/////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
// THIS SOFTWARE IS LICENSED UNDER THE BSD LICENSE
//Copyright (c) 2009, Max Bainrot
//All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
//
//    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
//    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
//    * Neither the name of the Max Bainrot nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
//
//THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
///////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////
// Project: gm_ircclient
// Author: Max Bainrot (Mr Puffy/Mbainrot)
// Date: 24 April 2009
// Current Version: 1.2 Build 200
// Purpose: Provide a generic IRC interface for Garry's Mod 10/11
// Contact: Find me on either Facepunch forums or on ICannt's forums/IRC

// Depends:
// (BUILD) Microsoft Visual C++ 2008 (Built under express edition)
// (BUILD) Half Life 2 SDK
// (BUILD) Garry's Mod Lua interface Header files
// .NET Framework 3.0
// Garrys Mod 10/11 (Current version of Garry's Mod as of 24th of April 2009
// 50% of a brain

// Methods:
// Table: "irc"
	//////////////////////////
	// CORE                 //
	//////////////////////////
		// Connection Management
		// Connect(host, port, nick, user, fullname)
		// Close()
		// SendRaw(str)
		// Debug (bool) - turns debug messages off

	//////////////////////////////////////////
	// Aux - for those who don't speak IRC  //
	//////////////////////////////////////////
		// SendMessage (target,msg)
		// Join (channel)
		// Part (channel)
		// NickServ (command)
		// GetVersion()
// Events:
	//IRC_OnChat(string nick, string channel, string msg)
	//IRC_OnNotice(string nick, string channel, string msg)
	//IRC_OnNickServ(string fullnick, string channel, string msg) (note that full nick is like nickname!username@host, also OnNotice is triggered too)
	//IRC_RawData(string rawdata)
	//IRC_EndOfMOTD()
	//IRC_ErroneusNick()
	//IRC_NickInUse()

// Special Thanks:
// Thank you to wacko from #c++ @ GameSurge (irc.gamesurge.net), with out your piece of help, 
//god knows where this would be
// Also Special thanks to the guys from ICannt.org for putting up with me using their servers as a test bed :)
// Finally thank you to Garry, for writing Garry's Mod, and releasing the header files thus making this possible.
// Refernces:
// gmsv_gatekeeper - Borrowed event handling code
// http://www.codeguru.com/forum/archive/index.php/t-261266.html
/////////////////////////////////////////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "GMLuaModule.h"
#include "gm_ircclient.h"
#include "version.h"

ILuaInterface* gLua;

cli::array<System::String ^>^ MySplit(System::String^ str,System::String^ Div)
{
cli::array<System::String ^>^ temp = gcnew cli::array<System::String ^>(1);

	int pos = str->IndexOf(Div);
	int i = 0;
	while(pos != -1){

		
		//Console::WriteLine(mystr->Substring(0,pos));
		temp[i] = gcnew System::String(str->Substring(0,pos));
		str = str->Substring(pos + (Div->Length));
		pos = str->IndexOf(Div);
		i++;
		temp->Resize(temp,i+1);
	}

return temp;
} // Made by yours truely ;) mbainrot

System::String ^ GetPRIVMSG(System::String ^ str,int part){
	if(part == 0){// we wants teh nick
		System::String^ TNick = str->Substring(1,str->IndexOf("!")-1);
		return TNick;
	} else {
		// we wantes teh message
		str= str->Substring(2);
		System::String^ TMsg = str->Substring(str->IndexOf(":")+1);
		return TMsg;
	}
} // Made by yours truely ;) mbainrot

public ref class Globals abstract sealed {
   public:
   // Vars
   static Socket^ client;
   static System::Threading::Timer^ myTimer; 
   static bool bDebug = true;
   // Functions
   static void SendIRCString(System::String^ strIRC){
	   if (Globals::client->Connected == false) 
		   return; // Sanity check

	   strIRC = strIRC + "\r\n";
	   cli::array<unsigned char>^ buffer = System::Text::Encoding::ASCII->GetBytes(strIRC);
	   Globals::client->Send(buffer);
   }
   
}; // Thanks to wacko from #c++ (irc.gamesurge.net) for this, without this, the whole project would not have
// gone ahead

GMOD_MODULE( Init, Shutdown );

/*  CODE SOURCED FROM gatekeeper.cpp (gmsv_gatekeeper)
	ILuaObject* hookCall = gLua->GetGlobal("hook")->GetMember("Call");

	gLua->Push(hookCall);

	gLua->Push("PlayerPasswordAuth");
	gLua->PushNil(); // Gamemode (Unnecessary, always nil)
	gLua->Push(Username);
	gLua->Push(Password);
	gLua->Push(SteamID);
	gLua->Push(netinfo->ToString());

	gLua->Call(6, 1);
*/

void DebugMessage(System::String^ str){
	str = str + "\n";
	IntPtr strptr = (Marshal::StringToHGlobalAnsi(str));
	const char* msg = (const char*)strptr.ToPointer();
	gLua->Msg(msg);
}

void ThrowOnChatEvent(System::String^ Nick, System::String^ Channel, System::String^ Message)
{
	IntPtr strptr = (Marshal::StringToHGlobalAnsi(Nick));
	const char* NewNick = (const char*)strptr.ToPointer();

	strptr = (Marshal::StringToHGlobalAnsi(Channel));
	const char* NewChannel = (const char*)strptr.ToPointer();

	strptr = (Marshal::StringToHGlobalAnsi(Message));
	const char* NewMessage = (const char*)strptr.ToPointer();

	ILuaObject* hookCall = gLua->GetGlobal("hook")->GetMember("Call");

	gLua->Push(hookCall);

	gLua->Push("IRC_OnChat");
	gLua->PushNil(); // Gamemode (Unnecessary, always nil)
	gLua->Push(NewNick);
	gLua->Push(NewChannel);
	gLua->Push(NewMessage);

	gLua->Call(5, 1);
}

void ThrowNoticeEvent(System::String^ Nick, System::String^ Channel, System::String^ Message)
{
	IntPtr strptr = (Marshal::StringToHGlobalAnsi(Nick));
	const char* NewNick = (const char*)strptr.ToPointer();

	strptr = (Marshal::StringToHGlobalAnsi(Channel));
	const char* NewChannel = (const char*)strptr.ToPointer();

	strptr = (Marshal::StringToHGlobalAnsi(Message));
	const char* NewMessage = (const char*)strptr.ToPointer();

	ILuaObject* hookCall = gLua->GetGlobal("hook")->GetMember("Call");

	gLua->Push(hookCall);

	gLua->Push("IRC_OnNotice");
	gLua->PushNil(); // Gamemode (Unnecessary, always nil)
	gLua->Push(NewNick);
	gLua->Push(NewChannel);
	gLua->Push(NewMessage);

	gLua->Call(5, 1);
}

void ThrowNickServEvent(System::String^ Nick, System::String^ Channel, System::String^ Message)
{
	IntPtr strptr = (Marshal::StringToHGlobalAnsi(Nick));
	const char* NewNick = (const char*)strptr.ToPointer();

	strptr = (Marshal::StringToHGlobalAnsi(Channel));
	const char* NewChannel = (const char*)strptr.ToPointer();

	strptr = (Marshal::StringToHGlobalAnsi(Message));
	const char* NewMessage = (const char*)strptr.ToPointer();

	ILuaObject* hookCall = gLua->GetGlobal("hook")->GetMember("Call");

	gLua->Push(hookCall);

	gLua->Push("IRC_OnNickServ");
	gLua->PushNil(); // Gamemode (Unnecessary, always nil)
	gLua->Push(NewNick);
	gLua->Push(NewChannel);
	gLua->Push(NewMessage);

	gLua->Call(5, 1);
}

void ThrowGenericEvent(const char * eventname)
{
	ILuaObject* hookCall = gLua->GetGlobal("hook")->GetMember("Call");

	gLua->Push(hookCall);

	gLua->Push(eventname);
	gLua->PushNil(); // Gamemode (Unnecessary, always nil)

	gLua->Call(2, 1);
}



void ProcessLine(System::String^ strLine)
{
	Debug::WriteLine("[PROCESS LINE CALL] " + strLine);
	cli::array<System::String ^>^ args = MySplit(strLine,(System::String ^)" ");

	
	int arglen = args->Length;

	if(strLine->Substring(0,4) == "PING"){
		Globals::SendIRCString("PONG " + strLine->Substring(5));
	}
	if(arglen > 2){ // Atleast 2 arguments?
		if(args[1] == "PRIVMSG"){
			if(GetPRIVMSG(strLine,1) == "VERSION")
				Globals::SendIRCString(L"NOTICE " + GetPRIVMSG(strLine,0) + L" :VERSION gm_ircclient, Version 1.2, Build " + VERSION_BUILD.ToString() + L", [Windows]");
			if(GetPRIVMSG(strLine,1) == "TIME")
				Globals::SendIRCString(L"NOTICE " + GetPRIVMSG(strLine,0) + L" :TIME to get a watch...");
	}

	}
	if(gLua == nullptr)
		return; // see if we can't get life support to work

	if(Globals::bDebug)
		DebugMessage("[libIRC] Arglen = " + arglen.ToString() + "\nLINE: " + strLine);

	// http://www.codeguru.com/forum/archive/index.php/t-261266.html
	IntPtr strptr = (Marshal::StringToHGlobalAnsi(strLine));
	const char* IRCRaw = (const char*)strptr.ToPointer();

	//const char * IRCRaw;

	/////////////////////////////////////////////////////////////
	// Throw LUA event
	/////////////////////////////////////////////////////////////
	ILuaObject* hookCall = gLua->GetGlobal("hook")->GetMember("Call");

	gLua->Push(hookCall);

	gLua->Push("IRC_RawData");
	gLua->PushNil(); // Gamemode (Unnecessary, always nil)
	gLua->Push(IRCRaw);

	gLua->Call(3, 1);

	if(arglen > 2){ // Atleast 2 arguments?
		if(args[1] == "PRIVMSG"){
			ThrowOnChatEvent(GetPRIVMSG(strLine,0),args[2],GetPRIVMSG(strLine,1));
		}

		if(args[1] == "NOTICE"){
			if(GetPRIVMSG(strLine,0)->ToLower() == "nickserv")
				ThrowNickServEvent(args[0],args[2],GetPRIVMSG(strLine,1));
			ThrowNoticeEvent(GetPRIVMSG(strLine,0),args[2],GetPRIVMSG(strLine,1));
		}

		if(args[1] == "376"){
			ThrowGenericEvent("IRC_EndOfMOTD");
		}

		if(args[1] == "432"){
			ThrowGenericEvent("IRC_ErroneusNick");
		}

		if(args[1] == "433"){
			ThrowGenericEvent("IRC_NickInUse");
		}
	}
	
}

void MessageCheckTimer()
{
	if(Globals::client->Connected == false)
		return;
	if(Globals::client->Available == 0)
		return;
	
	int datatorec=Globals::client->Available;
	
	cli::array<unsigned char>^ buffer = gcnew array<unsigned char>(datatorec);
	
	Globals::client->Receive(buffer);
	System::String^ data = System::Text::Encoding::ASCII->GetString(buffer);

	int pos = data->IndexOf((System::String ^)"\r\n");

	while(pos != -1)
	{
		ProcessLine(data->Substring(0,pos));
		data = data->Substring(pos+2);
		pos = data->IndexOf((System::String ^)"\r\n");
	}
}

void CALLBACK OnTimer(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
       MessageCheckTimer();
}

LUA_FUNCTION( Connect )
{

	if(Globals::client == nullptr || Globals::client->Connected)
	{
		gLua->Push("Invalid Socket!");
		gLua->Msg("[gm_ircclient] !! Globals::client is invalid!!\n");
		return 1;
	}

	// Pull Lua Arguments
	const char *host = gLua->GetString(1);
	int port = gLua->GetInteger(2);
	const char *old_nick = gLua->GetString(3);
    const char *old_user = gLua->GetString(4);
	const char *old_fullname = gLua->GetString(5);

	// host, port, nick, user, fullname

	// Convert to .NET strings (grr)
	System::String^ newhost = gcnew System::String(host);
	System::String^ nick = gcnew System::String(old_nick);
	System::String^ user = gcnew System::String(old_user);
	System::String^ fullname = gcnew System::String(old_fullname);

	Globals::client->Connect(newhost,port);

	Globals::SendIRCString("PASS alhflj234");
	Globals::SendIRCString("NICK " + nick);
	Globals::SendIRCString("USER " + user + " " + user + " " + user + " :" + fullname);


	// Setup the watch dog
	SetTimer(NULL,1,(UINT)100,(TIMERPROC)OnTimer);

	return 0;
}

LUA_FUNCTION( Close )
{
	//conn.quit("Leaving");
	Globals::SendIRCString("QUIT :Leaving");
	
	Globals::client->Close();

	return 0;
}

LUA_FUNCTION( SendRaw )
{
	const char *OldLine = gLua->GetString(1);
	System::String^ Line = gcnew System::String(OldLine);

	Globals::SendIRCString(Line);

	return 0;
}

	//////////////////////////////////////////
	// Aux - for those who don't speak IRC  //
	//////////////////////////////////////////

LUA_FUNCTION( SendMessage )
{
	const char *OldTarget = gLua->GetString(1);
	const char *OldMessage = gLua->GetString(2);

	System::String^ Target = gcnew System::String(OldTarget);
	System::String^ Message = gcnew System::String(OldMessage);

	Globals::SendIRCString("PRIVMSG " + Target + " :" + Message);

	return 0;
}

LUA_FUNCTION( Join )
{
	const char *OldTarget = gLua->GetString(1);	
	System::String^ Target = gcnew System::String(OldTarget);

	Globals::SendIRCString("JOIN " + Target);

	return 0;
}

LUA_FUNCTION( Part )
{
	const char *OldTarget = gLua->GetString(1);	
	System::String^ Target = gcnew System::String(OldTarget);

	Globals::SendIRCString("PART " + Target);

	return 0;
}

LUA_FUNCTION(bDebug)
{
	Globals::bDebug = gLua->GetBool(1);

	return 0;
}

LUA_FUNCTION(NickServ)
{
	const char *OldTarget = gLua->GetString(1);	
	System::String^ Target = gcnew System::String(OldTarget);

	Globals::SendIRCString("NICKSERV " + Target);

	return 0;
}

LUA_FUNCTION(GetVersion)
{
	char *MyVersion;
	sprintf(MyVersion,"Ver %d.%d BUILD %d",VERSION_MAJOR,VERSION_MINOR,VERSION_BUILD);

	gLua->Push((const char *)MyVersion);

	return 1;
}
//-----------------------------------------------------------------------------
// Called when the DLL is being initialized
//-----------------------------------------------------------------------------
int Init( lua_State* L )
{
	if(Globals::client == nullptr)
		Globals::client = gcnew Socket(System::Net::Sockets::AddressFamily::InterNetwork,System::Net::Sockets::SocketType::Stream,System::Net::Sockets::ProtocolType::Tcp);

	gLua = Lua();
	//Globals::client->
	// Make our global table
	Lua()->NewGlobalTable( "irc" );
	
	// Add the members
	ILuaObject* irc = Lua()->GetGlobal( "irc" );

	//////////////////////////
	// CORE                 //
	//////////////////////////
		// Connection Management
		// Connect(host, port, nick, user, fullname)
		irc->SetMember( "Connect", Connect );
		// Close()
		irc->SetMember( "Close", Close );
		// SendRaw(str)
		irc->SetMember("SendRaw",SendRaw);
		// Debug (bool) - turns debug messages off
		irc->SetMember("Debug",bDebug);

	//////////////////////////////////////////
	// Aux - for those who don't speak IRC  //
	//////////////////////////////////////////
		// SendMessage (target,msg)
		irc->SetMember("SendMessage",SendMessage);
		// Join/Part (target)
		irc->SetMember("Join",Join);
		irc->SetMember("Part",Part);
		// NickServ
		irc->SetMember("NickServ",NickServ);
		// VERSIONING
		irc->SetMember("GetVersion",GetVersion);


		return 0;
}

//-----------------------------------------------------------------------------
// Called when the DLL is being unloaded. 
//-----------------------------------------------------------------------------
int Shutdown( lua_State* L )
{
/*
	if(Globals::client->Connected == true)
		Globals::SendIRCString("QUIT :Leaving");
	
	Globals::client->Close();

	delete Globals::client;
	Globals::client == nullptr;
//*/

	gLua = nullptr;
	return 0;
}