if irc == nil then
	require("ircclient")
end

if SERVER then
return  // SORRY CLIENTSIDE ONLY
end

local bDrawHUD = true
local bConnected = false

local ScreenBuffer = {}

local function IRC_ScreenBuffer(str)
	if table.Count(ScreenBuffer) >= 10 then
		table.remove(ScreenBuffer,1)
	end
	
	table.insert(ScreenBuffer,str)
end

//////////////////////////////////////////////////////////////////////////////
// Name: Test IRC client
// Concommands:
// istart server port nick
// inick nick
// isay #channel message
// ijoin #channel
// ipart #channel
// ihud [0|1] 
//////////////////////////////////////////////////////////////////////////////

// Do concommands first :)
local function ProcCMD(ply,cmd,args)
	if cmd == "istart" then
		irc.Connect(args[1],tonumber(args[2]),args[3],args[3],args[3]);
		timer.Create( "ircclient_msgcheck", 0.10, 0,function() irc.MessageCheck() end);
		bConnected = true;
	end
	if cmd == "inick" then
		// Not implemented
	end
	if cmd == "isay" then
		local msg = ""
		local channel = args[1]
		for i=2,table.Count(args) do
			msg = msg .. tostring(args[i]) .. " "
		end		
		IRC_ScreenBuffer("<< ME " .. channel .. ": " .. msg)
		irc.SendMessage(channel,msg)
	end
	if cmd == "ijoin" then
		irc.Join(args[1])
	end
	if cmd == "ipart" then
		irc.Part(args[1])
	end
	if cmd == "ihud" then
		if args[1] == "0" then
			bDrawHUD = false
		else
			bDrawHUD = true
		end
	end
end
concommand.Add("istart",ProcCMD)
concommand.Add("isay",ProcCMD)
concommand.Add("ijoin",ProcCMD)
concommand.Add("ipart",ProcCMD)
concommand.Add("ihud",ProcCMD)

local function IRC_OnChat(nick,chan,msg)
	//local metime = os.date("%T")
	local metime = "hh:mm:ss"
	IRC_ScreenBuffer("[" .. metime .. "] " .. nick .. "@" .. chan .. ": " .. msg) 
end
hook.Add("IRC_OnChat","IRCCLIENT_OnChat",IRC_OnChat)

/////////////////////////////////////////////////////////////////////////////////////
// HUD DRAW STUFF
/////////////////////////////////////////////////////////////////////////////////////

// Init
surface.CreateFont( "arial", 12, 400, true, false, "IRCFont" )
local COLOR_IRCCHAT = Color(0, 255, 0, 255)
local COLOR_IRCCHATBOX = Color(50,50,50,200)

local startx = 30
local starty = 120

// Init draw table to stop fuck ups
for i=1,10 do
	table.insert(ScreenBuffer,"")
end

local function IRC_HUDPaint()
	for i=1,10 do
		if ScreenBuffer[i] != nil then
			if ScreenBuffer[i] != "" then
				//draw.SimpleText(tostring(ScreenBuffer[i]), "IRCFont", startx, starty + (13*i), COLOR_IRCCHAT, TEXT_ALIGN_LEFT)
				draw.WordBox(1,startx,starty + (14*i),tostring(ScreenBuffer[i]),"IRCFont",COLOR_IRCCHATBOX,COLOR_IRCCHAT)
			end
		end
	end
end
hook.Add("HUDPaint","IRC_HUDPaint",IRC_HUDPaint)

local function unload_irc_client(ply,cmd,args)
	hook.Remove("HUDPaint","IRC_HUDPaint")
	hook.Remove("IRC_OnChat","IRCCLIENT_OnChat")
	
	concommand.Remove("istart")
	concommand.Remove("isay")
	concommand.Remove("ijoin")
	concommand.Remove("ipart")
	concommand.Remove("ihud")
	concommand.Remove("unload_irc_client")
end
concommand.Add("unload_irc_client",unload_irc_client)